unit Unit14;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCMapsCommonTypes,
  VCL.TMSFNCCustomControl, VCL.TMSFNCWebBrowser, VCL.TMSFNCMaps,
  Vcl.ComCtrls, Vcl.StdCtrls, VCL.TMSFNCCustomComponent,
  VCL.TMSFNCRouteCalculator, Vcl.ExtCtrls;

type
 TForm1 = class(TForm)
    Button1: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TMSFNCMaps1: TTMSFNCMaps;
    RadioGroup1: TRadioGroup;
    EditApiKey: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditApiKeyExit(Sender: TObject);
  private
    { Private declarations }
    xPolyPopUpId : string;
    arr: TTMSFNCMapsCoordinateRecArray;
    procedure SetPointArray;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  p: TTMSFNCMapsPolyline;
  i : integer;
  m : TTMSFNCMapsMarker;

begin
  TMSFNCMaps1.BeginUpdate;
  TMSFNCMaps1.Polylines.clear;
  TMSFNCMaps1.Markers.Clear;

  p := TMSFNCMaps1.AddPolyline(arr);
  p.StrokeColor := clGreen;
  p.StrokeWidth := 6;
  p.StrokeOpacity := 0.75;

  for i := Low(arr) to High(arr) do
    begin
      m := TMSFNCMaps1.Markers.Add;
      m.Coordinate.Latitude := arr[i].Latitude;
      m.Coordinate.Longitude := arr[i].Longitude;
    end;
  TMSFNCMaps1.EndUpdate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TMSFNCMaps1.ZoomToBounds(arr);
end;

procedure TForm1.EditApiKeyExit(Sender: TObject);
begin
  RadioGroup1Click(nil);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  xPolyPopUpId := '';
  SetPointArray;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  SetLength(arr, 0);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  If RadioGroup1.ItemIndex = 0 then
    begin
      TMSFNCMaps1.Service := msOpenLayers;
      TMSFNCMaps1.ApiKey := '';
    end
  else If RadioGroup1.ItemIndex = 1 then
    begin
      TMSFNCMaps1.ApiKey := EditApiKey.Text;
      TMSFNCMaps1.Service := msGoogleMaps;
    end
  else If RadioGroup1.ItemIndex = 2 then
    begin
      TMSFNCMaps1.ApiKey := EditApiKey.Text;
      TMSFNCMaps1.Service := msHere;
    end
end;

procedure TForm1.SetPointArray;
begin
  SetLength(arr, 3);
//  i:=0;
  arr[0] := CreateCoordinate(54.261458, 18.520031);
  arr[0].Description := 'Browar Amber';
  arr[0].TimeStamp := now;
  arr[0].HasTimeStamp := true;

  arr[1] := CreateCoordinate(54.26919610341799, 18.468079966611043);
  arr[1].Description := 'Piekarnia';
  arr[1].TimeStamp := now;
  arr[1].HasTimeStamp := true;

  arr[2] := CreateCoordinate(54.342157424935934, 18.359854842866586);
  arr[2].Description := 'Orlen';
  arr[2].TimeStamp := now;
  arr[2].HasTimeStamp := true;
end;

end.

